



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java内存分配机制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java内存分配机制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 09:23:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>内存分配，主要指的是在<strong>堆</strong>上的分配，</p>
<p>一般的，对象的内存分配都是在堆上进行，但现代技术也支持将对象拆成标量类型（标量类型即原子类型，表示单个值，可以是基本类型或String等），然后在栈上分配，在栈上分配的很少见，我们这里不考虑。</p>
<p><strong>Java内存分配和回收的机制</strong>概括的说，就是：<strong>分代分配，分代回收</strong>。</p>
<p>对象将根据存活的时间被分为：年轻代（Young Generation）、年老代（Old Generation）、永久代（Permanent Generation，也就是方法区）。</p>
<p>如下图（来源于《成为JavaGC专家part I》，http://www.importnew.com/1993.html）：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1064427/201904/1064427-20190403110626487-1761462182.png" /></p>
<p><strong>年轻代（Young Generation）</strong>：对象被创建时，内存的分配首先发生在年轻代（大对象可以直接 被创建在年老代），大部分的对象在创建后很快就不再使用，因此很快变得不可达，于是被年轻代的GC机制清理掉（IBM的研究表明，98%的对象都是很快消 亡的），这个GC机制被称为Minor GC或叫Young GC。注意，Minor GC并不代表年轻代内存不足，它事实上只表示在Eden区上的GC。</p>
<p>年轻代上的内存分配是这样的，年轻代可以分为3个区域：Eden区（伊甸园，亚当和夏娃偷吃禁果生娃娃的地方，用来表示内存首次分配的区域，再 贴切不过）和两个存活区（Survivor 0 、Survivor 1）。内存分配过程为（来源于《成为JavaGC专家part I》，http://www.importnew.com/1993.html）：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1064427/201904/1064427-20190403144114483-1656031286.png" /></p>
<ol><li>绝大多数刚创建的对象会被分配在Eden区，其中的大多数对象很快就会消亡。Eden区是连续的内存空间，因此在其上分配内存极快；</li>
<li>当Eden区满的时候，执行Minor GC，将消亡的对象清理掉，并将剩余的对象复制到一个存活区Survivor0（此时，Survivor1是空白的，两个Survivor总有一个是空白的）；</li>
<li>此后，每次Eden区满了，就执行一次Minor GC，并将剩余的对象都添加到Survivor0；</li>
<li>当Survivor0也满的时候，将其中仍然活着的对象直接复制到Survivor1，以后Eden区执行Minor GC后，就将剩余的对象添加Survivor1（此时，Survivor0是空白的）。</li>
<li>当两个存活区切换了几次（HotSpot虚拟机默认15次，用-XX:MaxTenuringThreshold控制，大于该值进入老年代）之后，仍然存活的对象（其实只有一小部分，比如，我们自己定义的对象），将被复制到老年代。</li></ol>
<p>　　从上面的过程可以看出，Eden区是连续的空间，且Survivor总有一个为空。经过一次GC和复制，一个Survivor中保存着当前还活 着的对象，而Eden区和另一个Survivor区的内容都不再需要了，可以直接清空，到下一次GC时，两个Survivor的角色再互换。因此，这种方 式分配内存和清理内存的效率都极高，这种垃圾回收的方式就是著名的<strong>&ldquo;停止-复制（Stop-and-copy）&rdquo;清理法（将Eden区和一个Survivor中仍然存活的对象拷贝到另一个Survivor中）</strong>，这不代表着停止复制清理法很高效，其实，它也只在这种情况下高效，如果在老年代采用停止复制，则挺悲剧的。</p>
<p>　　在Eden区，HotSpot虚拟机使用了两种技术来加快内存分配。分别是bump-the-pointer和TLAB（Thread- Local Allocation Buffers），这两种技术的做法分别是：由于Eden区是连续的，因此bump-the-pointer技术的核心就是跟踪最后创建的一个对象，在对 象创建时，只需要检查最后一个对象后面是否有足够的内存即可，从而大大加快内存分配速度；而对于TLAB技术是对于多线程而言的，将Eden区分为若干 段，每个线程使用独立的一段，避免相互影响。TLAB结合bump-the-pointer技术，将保证每个线程都使用Eden区的一段，并快速的分配内 存。</p>
<p><strong>　　年老代（Old Generation）</strong>：对象如果在年轻代存活了足够长的时间而没有被清理掉（即在几次 Young GC后存活了下来），则会被复制到年老代，年老代的空间一般比年轻代大，能存放更多的对象，在年老代上发生的GC次数也比年轻代少。当年老代内存不足时， 将执行Major GC，也叫 Full GC。　　</p>
<div>
<div>&nbsp;　　可以使用-XX:+UseAdaptiveSizePolicy开关来控制是否采用动态控制策略，如果动态控制，则动态调整Java堆中各个区域的大小以及进入老年代的年龄。</div>
<p>　　如果对象比较大（比如长字符串或大数组），Young空间不足，则大对象会直接分配到老年代上（大对象可能触发提前GC，应少用，更应避免使用短命的大对象）。用-XX:PretenureSizeThreshold来控制直接升入老年代的对象大小，大于这个值的对象会直接分配在老年代上。</p>
</div>
<p>　　可能存在年老代对象引用新生代对象的情况，如果需要执行Young GC，则可能需要查询整个老年代以确定是否可以清理回收，这显然是低效的。解决的方法是，年老代中维护一个512 byte的块&mdash;&mdash;&rdquo;card table&ldquo;，所有老年代对象引用新生代对象的记录都记录在这里。Young GC时，只要查这里即可，不用再去查全部老年代，因此性能大大提高。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/p49gdz97.html">前端css兼容性与易混淆的点</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93wjwnq.html">&period;NET中使用APlayer组件自制播放器</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx66jdq.html">armv6&comma; armv7&comma; armv7s的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxr4wjq.html">java代码和spring框架读取xml和properties文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4527n9.html">spring优化使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxvymj9.html">TextEdit 回车事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o3zvj9.html">清空FORM表单的几种方式 Reset 重加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv7mz1q.html">Web前端新人笔记之jquery入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmrwox9.html">Js菜鸟学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpk7z59.html">&lbrack;js高手之路&rsqb; html5新增的定时器requestAnimationFrame实战进度条</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd6j379.html">nodejs批量导入数据eventproxy（回调函数嵌套解决方案）使用实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mov2j8.html">第三章 启动rabbitmq的webUI</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oxwdx8.html">将VMware虚拟机系统镜像导入到ESXi vSphere</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25wwmwq.html">SpringBoot项目如何打War包</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r53yzrq.html">解决vue &amp;lt&semi;router-link&amp;gt&semi;在IE与火狐上点击失效（路由不跳转）问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnwl7mq.html">c&num; 生成随机N位数字串（每位可以重复）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v22r2q.html">react父子组件数据传递</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko4zzrq.html">SQL语句200条（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp4lrk9.html">PL&sol;SQL之存储过程和触发器实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1velr5q.html">Oracle学习&lpar;八&rpar;：处理数据</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gdmy0q.html">linux中时间命令详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy3rz19.html">《Python编程》课程报告 python技术在数据分析中的应用之网络爬虫</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdyymd9.html">Linux之grep的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjgz1e9.html">【Python全栈-后端开发】Django进阶之Model操作复习</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy3e3x9.html">Cocos 2dx项目lua调用OC出现卡死但不闪退的坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7od0v18.html">python基础&lpar;10&rpar;-匿名函数&amp;amp&semi;内置函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1y2weq.html">VUE中的v-show和v-if</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jd603q.html">JAVA微信支付代码（WeChatPay&period;java 才是调用类）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdyjke9.html">TheFatRat一般使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllvd31q.html">压缩图片 Image</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
